package com.ccb.mobile.platform.utils;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

public class DESSecretTool {
  /**
   * 初始化向量,长度为8的字节数组
   */
  private static byte[] iv = { 1, 2, 3, 4, 5, 6, 7, 8 };
  /**
   * 密码，长度必须为8
   */
  private static final String KEY = "CCBKEYWD";

  /**
   * 加密方法
   * 
   * @param encryptString
   * @return
   * @throws Exception
   */
  public static String encrypt(String encryptString) throws Exception {
    if (encryptString == null || "".equals(encryptString))
      return "";
    // IvParameterSpec zeroIv = new IvParameterSpec(new byte[8]);
    IvParameterSpec zeroIv = new IvParameterSpec(iv);
    SecretKeySpec key = new SecretKeySpec(KEY.getBytes(), "DES");
    Cipher cipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
    cipher.init(Cipher.ENCRYPT_MODE, key, zeroIv);
    byte[] encryptedData = cipher.doFinal(encryptString.getBytes());
    return Base64.encode(encryptedData);
  }

  /**
   * 解密方法
   * 
   * @param decryptString
   * @return
   * @throws Exception
   */
  public static String decrypt(String decryptString) throws Exception {
    if (decryptString == null || "".equals(decryptString))
      return "";
    byte[] byteMi = new Base64().decode(decryptString);
    IvParameterSpec zeroIv = new IvParameterSpec(iv);
    // IvParameterSpec zeroIv = new IvParameterSpec(new byte[8]);
    SecretKeySpec key = new SecretKeySpec(KEY.getBytes(), "DES");
    Cipher cipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
    cipher.init(Cipher.DECRYPT_MODE, key, zeroIv);
    byte decryptedData[] = cipher.doFinal(byteMi);
    String str = new String(decryptedData).trim();
    return str.equalsIgnoreCase("null")?null:str;
  }

}
